/*-
 * ========================LICENSE_START=================================
 * org.etsi.osl.tmf.api
 * %%
 * Copyright (C) 2019 - 2021 openslice.io
 * %%
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * 
 *      http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * =========================LICENSE_END==================================
 */
package org.etsi.osl.tmf.am642.model;

public enum ProbableCauseType {
	abisBtsInterfaceFailure,
	abisTrxInterfaceFailure,
	adapterError,
	airCompressorFailure,
	airConditioningFailure,
	airDryerFailure,
	ais,
	antennaFailure,
	applicationSubsystemFailure,
	authenticationFailure,
	backplaneFailure,
	bandwidthReduced,
	batteryBreakdown,
	batteryChargingFailure,
	batteryDischarging,
	batteryFailure,
	breachOfConfidentiality,
	broadcastChannelFailure,
	cableTamper,
	callEstablishmentError,
	callSetUpFailure,
	clockSynchronizationProblem,
	combinerProblem,
	commercialPowerFailure,
	communicationsProtocolError,
	communicationsSubsystemFailure,
	configurationOrCustomizationError,
	congestion,
	connectionEstablishmentError,
	coolingFanFailure,
	coolingSystemFailure,
	corruptData,
	cpuCyclesLimitExceeded,
	dataSetOrModemError,
	databaseInconsistency,
	degradedSignal,
	delayedInformation,
	demodulationFailure,
	denialOfService,
	diskFailure,
	duplicateInformation,
	enclosureDoorOpen,
	engineFailure,
	equipmentFailure,
	equipmentIdentifierDuplication,
	excessiveBitErrorRate,
	excessiveReceiverTemperature,
	excessiveResponseTime,
	excessiveRetransmissionRate,
	excessiveTransmitterOutputPower,
	excessiveTransmitterTemperature,
	excessiveVibration,
	explosiveGas,
	externalEquipmentFailure,
	externalIfDeviceProblem,
	externalPointFailure,
	externalPowerSupplyFailure,
	externalTransmissionDeviceFailure,
	farEndReceiverFailure,
	fileError,
	fileSystemCallUnsuccessful,
	fire,
	fireDetectorFailure,
	flood,
	framingError,
	frequencyHoppingDegraded,
	frequencyHoppingFailure,
	frequencyRedefinitionFailed,
	fuseFailure,
	generatorFailure,
	heatingVentCoolingSystemProblem,
	highHumidity,
	highTemperature,
	highWind,
	humidityUnacceptable,
	iceBuildUp,
	informationMissing,
	informationModificationDetected,
	informationOutOfSequence,
	inputDeviceError,
	inputOutputDeviceError,
	inputParameterOutOfRange,
	intrusionDetection,
	invalidMessageReceived,
	invalidParameter,
	invalidPointer,
	ioDeviceError,
	keyExpired,
	lanError,
	lapdLinkProtocolFailure,
	leakDetected,
	lineCardProblem,
	lineInterfaceFailure,
	linkFailure,
	localAlarmIndication,
	localNodeTransmissionError,
	lossOfFrame,
	lossOfMultiFrame,
	lossOfPointer,
	lossOfRealTime,
	lossOfRedundancy,
	lossOfSignal,
	lossOfSynchronisation,
	lowBatteryThreshold,
	lowCablePressure,
	lowFuel,
	lowHumidity,
	lowTemperatue,
	lowWater,
	mainsBreakdownWithBatteryBackUp,
	mainsBreakdownWithoutBatteryBackUp,
	materialSupplyExhausted,
	memoryMismatch,
	messageNotExpected,
	messageNotInitialized,
	messageOutOfSequence,
	modulationFailure,
	multiplexerProblem,
	neIdentifierDuplication,
	nonRepudiationFailure,
	other,
	ouputDeviceError,
	outOfCpuCycles,
	outOfHoursActivity,
	outOfMemory,
	outOfService,
	pathTraceMismatch,
	payloadTypeMismatch,
	performanceDegraded,
	powerProblems,
	powerSupplyFailure,
	pressureUnacceptable,
	proceduralError,
	processorProblem,
	protectingResourceFailure,
	protectionMechanismFailure,
	protectionPathFailure,
	pumpFailure,
	queueSizeExceeded,
	realTimeClockFailure,
	receiveFailure,
	receiverAntennaFault,
	receiverFailure,
	receiverMulticouplerFailure,
	rectifierFailure,
	rectifierHighVoltage,
	rectifierLowVoltage,
	reducedAlarmReporting,
	reducedEventReporting,
	reducedLoggingCapability,
	reducedTransmitterOutputPower,
	reinitialized,
	remoteAlarmIndication,
	remoteAlarmInterface,
	remoteNodeTransmissionError,
	replaceableUnitMissing,
	replaceableUnitProblem,
	replaceableUnitTypeMismatch,
	resourceAtOrNearingCapacity,
	responseTimeExecessive,
	retransmissionRateExcessive,
	routingFailure,
	signalLabelMismatch,
	signalQualityEvaluationFailure,
	smoke,
	softwareDownloadFailure,
	softwareEnvironmentProblem,
	softwareError,
	softwareProgramAbnormallyTerminated,
	softwareProgramError,
	ss7ProtocolFailure,
	storageCapacityProblem,
	synchronizationSourceMismatch,
	systemCallUnsuccessful,
	systemResourcesOverload,
	temperatureUnacceptable,
	terminalProblem,
	thresholdCrossed,
	timeoutExpired,
	timeslotHardwareFailure,
	timingProblem,
	toxicGas,
	toxicLeakDetected,
	transceiverFailure,
	transcoderOrRateAdapterProblem,
	transcoderProblem,
	transmissionError,
	transmitFailure,
	transmiterFailure,
	transmitterAntennaFailure,
	transmitterAntennaNotAdjusted,
	transmitterFailure,
	transmitterLowVoltageOrCurrent,
	transmitterOffFrequency,
	trunkCardProblem,
	unauthorizedAccessAttempt,
	unavailable,
	underlyingResourceUnavailable,
	unexpectedInformation,
	variableOutOfRange,
	ventilationsSystemFailure,
	versionMismatch,
	watchdogTimerExpired
}
